
title: Download
description: none

====

## NPM

``` sh
npm install riot -g
```

### Compiler

Riot compiler transforms `.tag` files to `.js` for browsers. For example:

``` sh
open demo/index.html
riot --watch demo
```

This watches .tag file changes on the demo folder and generates .js files automatically. See [compiler guide](/riotjs/guide/#compiler) or run `riot --help` for more information.


## Git

<span class="tag">URL</span> https://github.com/muut/riotjs

Please clone the repository and run the demo locally.

``` sh
git clone git@github.com:muut/riotjs.git
open demo/index.html
make watch
```

You can now edit `demo/todo.tag` file and the compiler automatically watch for changes and transforms it to .js file.


## Download

[demo.zip](/riotjs/dist/riot-{{ riot_version }}.zip) - Working demo with unminified version

[riot.min.js](/riotjs/dist/riot-{{ riot_version }}.min.js) – For production. 5.5K minified / 2.5K gzipped

[riot.js](/riotjs/dist/riot-{{ riot_version }}.js) – For development

## IE8 support

IE8 requires that both [es5-shim](https://github.com/es-shims/es5-shim) and [html5-shiv](https://github.com/aFarkas/html5shiv) are included on the `<head>` of your page and IE is configured to work with the latest rendering engine. Here's how you do it:

``` html
<head>
  <meta http-equiv="X-UA-Compatible" content="IE=edge">

  <!--[if IE 8]>
    <script src="es5-shim.js"></script>
    <script src="html5-shiv.js"></script>
    &lt;script>html5.addElements('test')</script>
  <![endif]-->
</head>
```

You can see a working example on the [demo.zip](/riotjs/dist/riot-{{ riot_version }}.zip). IE7 and below are not supported.

You also need to tell IE8 what custom tags are being used on the page as follows:

``` html
&lt;script>html5.addElements('todo todo-item account plan')</script>
```

That's a space separated list of tag names.


## Known issues

On current version conditionals are implemented with `style="display: none"`. This will be fixed on upcoming version where `if` attribute will add/remove the element from the DOM completely.



